# Build a Simple Tx with cardano-cli

Now that you built a new address, you can use it.

In this module, we will distinguish between the "Browser Wallet" that you created in [Lesson 100.1](/modules/100/1001) and the "CLI Wallet" that you created in [Lesson 102.2](/modules/102/1022).

## Do This First: Send tADA to Your New Wallet
You will need some tADA in your [new wallet](/modules/102/1022). Send at least 100 tADA from your Browser Wallet to your CLI Wallet.

<br />
---

## Definitions: Transactions and UTxOs
- A **transaction** moves value from one address to another.
- On Cardano, "value" is stored in **UTxOs**, the abbreviation "Unspent Transaction Output".
- Every transaction takes Unspent Transaction Outputs, or UTxOs, as input and creates one or more UTxOs as output.
- After a transaction, the new UTxOs are "unspent", which means they're available for spending.
- Take a moment to think about what happens to the UTxOs used as input to a transaction. Are they still unspent?


<br />
---

## 1. Set Variables and Select UTxOs
Now we will build a transaction, step-by-step, using `cardano-cli`.

We will only sometimes build transactions this way. We provide this exploration to help you learn about Transactions and UTxOs.

Building transactions in the terminal can help set some variables we will reuse. For example:
```bash
SENDERADDRESS=<THE ADDRESS GENERATED IN LESSON 102.2>
SENDERKEY=<THE SIGNING KEY FOR THIS ADDRESS>
```

Then, view your list of UTxOs:
```bash
cardano-cli query utxo --testnet-magic 1 --address $SENDERADDRESS
```

And indicate the UTxO you want to spend:
```bash
UTXO_IN=<TxHash>#<TxId>
```

#### Watch the video above to see how to complete this step.


---

## 2. Build a Tx

When building on a blockchain, referring to a transaction as a "Tx" is common. Look for it!

Here is a simple transaction with one input and one output. We can specify the recipient address like this:
```bash
 RECIPIENT_ADDRESS=<Any preprod address>
```

If you set each of the variables correctly, you can copy and paste this `transaction build` command into the terminal:

```bash
cardano-cli transaction build \
--babbage-era \
--testnet-magic 1 \
--tx-in $UTXO_IN \
--tx-out $RECIPIENT_ADDRESS+$LOVELACE_TO_SEND \
--change-address $SENDERADDRESS \
--out-file simple-tx.raw
```

#### Watch the video above to see how to complete this step.

<br />
---

## 3. Sign a Tx

If `transaction build` was successful, sign the transaction. Here, the `--tx-body-file` must match the `--out-file` from Step 2:

```bash
$ cardano-cli transaction sign \
--signing-key-file $SENDERKEY \
--testnet-magic 1 \
--tx-body-file simple-tx.raw \
--out-file simple-tx.signed
```

<br />
---

## 4. Submit a Tx

It's the same idea moving from signing the transaction to submitting it:

```bash
$ cardano-cli transaction submit \
--tx-file simple-tx.signed \
--testnet-magic 1

```

<br />
---

## Putting it all together:
```bash
cardano-cli transaction build \
--babbage-era \
--testnet-magic 1 \
--tx-in $UTXO_IN \
--tx-out $SENDERADDRESS+$LOVELACE_TO_SEND \
--change-address $SENDERADDRESS \
--out-file simple-tx.raw

cardano-cli transaction sign \
--signing-key-file $SENDERKEY \
--testnet-magic 1 \
--tx-body-file simple-tx.raw \
--out-file simple-tx.signed

cardano-cli transaction submit \
--tx-file simple-tx.signed \
--testnet-magic 1
```

<br />
---

## That's the idea!

In [Lesson 102.6](/modules/102/1026), we'll share a `bash` script that automates this transaction.

But first, let's see what else we can do with `transaction build`.



import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
